# $Id: AccessLog.rb,v 1.7 2005/01/16 11:08:10 toki Exp $

require 'forwardable'

class AccessLog < WPM::PageContext
  extend Forwardable

  def init_context
    @control = page_option(:control)
    @params = @control.access_log_params
    @index = nil
    @logfile = nil
  end

  def_delegator :@params, :modified_count
  def_delegator :@params, :modified_count=
  def_delegator :@params, :logging
  def_delegator :@params, :logging=
  def_delegator :@params, :format
  def_delegator :@params, :format=

  def has_logfiles?
    ! @params.logfiles.empty?
  end

  def logfile_list
    list = Array.new
    @params.logfiles.each_with_index do |logfile, i|
      list.push({ :params => logfile, :pos => i })
    end

    list
  end

  attr_accessor :index
  attr_writer :logfile

  def __logfile__
    @logfile[:params]
  end
  private :__logfile__

  def_delegator :__logfile__, :path, :logfile_path
  def_delegator :__logfile__, :path=, :logfile_path=
  def_delegator :__logfile__, :format, :logfile_format
  def_delegator :__logfile__, :format=, :logfile_format=

  def del_logfile
    pos = @logfile[:pos]
    if (pos < 0 || @params.logfiles.length <= pos) then
      raise 'out of range'
    end
    @params.del_logfile_at(pos)
    @control.set_access_log_params(@params)
    nil
  end

  def write
    @control.set_access_log_params(@params)
    nil
  end
end
