# $Id: Logging.rb,v 1.5 2005/01/14 15:41:25 toki Exp $

require 'forwardable'

class Logging < WPM::PageContext
  extend Forwardable

  def init_context
    @control = page_option(:control)
    @params = @control.logging_params
    @index = nil
    @logfile = nil
  end

  def_delegator :@params, :modified_count
  def_delegator :@params, :modified_count=
  def_delegator :@params, :stdout_logging_level
  def_delegator :@params, :stdout_logging_level=

  def has_logfiles?
    ! @params.logfiles.empty?
  end

  def logfile_list
    logfile_list = Array.new
    @params.logfiles.each_with_index do |logfile, i|
      logfile_list.push({ :params => logfile, :pos => i })
    end

    logfile_list
  end

  attr_accessor :index
  attr_writer :logfile

  def __logfile__
    @logfile[:params]
  end
  private :__logfile__

  def_delegator :__logfile__, :path, :logfile_path
  def_delegator :__logfile__, :path=, :logfile_path=
  def_delegator :__logfile__, :logging_level, :logfile_logging_level
  def_delegator :__logfile__, :logging_level=, :logfile_logging_level=

  def del_logfile
    pos = @logfile[:pos]
    if (pos < 0 || @params.logfiles.length <= pos) then
      raise 'out of range'
    end
    @params.del_logfile_at(pos)
    @control.set_logging_params(@params)
    nil
  end

  def write
    @control.set_logging_params(@params)
    nil
  end
end
