# $Id: Navigation.rb,v 1.5 2005/02/05 16:12:52 toki Exp $

class Navigation < WPM::PageContext
  include WPM::Escape

  def init_context
    @control = page_option(:control)
    @driver = driver
    @page = nil
    @query = Hash.new
    @hidden_param_name = nil
    @hidden_param_value = nil
  end

  def server_restart
    @driver.set_header('Connection', 'close')
    @control.server_restart
    nil
  end

  def server_close
    @driver.set_header('Connection', 'close')
    @control.server_close
    nil
  end

  attr_accessor :page
  attr_accessor :query

  def has_hidden_params?
    ! @query.empty?
  end

  def hidden_param_list
    @query
  end

  def hidden_param=(param_pair)
    @hidden_param_name, @hidden_param_value = param_pair
  end

  attr_reader :hidden_param_name
  attr_reader :hidden_param_value

  def control_panel?
    @page == 'ControlPanel'
  end

  def mount_map?
    @page == 'MountMap' || @page == 'SetupDocument'
  end

  def filter_map?
    @page == 'FilterMap' || @page == 'SetupFilter'
  end

  def alias_map?
    @page == 'AliasMap' || @page == 'SetupAlias'
  end

  def logging?
    @page == 'Logging' || @page == 'AddLogFile'
  end

  def access_log?
    @page == 'AccessLog' || @page == 'AddAccessLog'
  end

  def error?
    @page == 'ServerError' || @page == 'ServerErrorInfo'
  end

  def administrator?
    @page == 'Administrator' || @page == 'AdminPassword'
  end

  def about?
    @page == 'About'
  end
end
