# $Id: ServerError.rb,v 1.1 2005/02/05 01:41:17 toki Exp $

require 'forwardable'

class ServerError < WPM::PageContext
  extend Forwardable

  def init_context
    @control = page_option(:control)
    @error_sample = nil
  end

  def_delegator :@control, :setup_load_errors
  def_delegator :@control, :setup_logging_errors
  def_delegator :@control, :setup_alias_errors
  def_delegator :@control, :setup_document_errors
  def_delegator :@control, :setup_filter_errors

  def has_load_errors?
    @control.setup_load_errors.length > 0
  end

  def has_logging_errors?
    @control.setup_logging_errors.length > 0
  end

  def has_alias_errors?
    @control.setup_alias_errors.length > 0
  end

  def has_document_errors?
    @control.setup_document_errors.length > 0
  end

  def has_filter_errors?
    @control.setup_filter_errors.length > 0
  end

  attr_writer :error_sample
  def_delegator :@error_sample, :timestamp
  def_delegator :@error_sample, :error_message
  def_delegator :@error_sample, :error_type

  def load_error_query
    { 'type' => 'load',
      'id' => @control.setup_load_errors.index(@error_sample).to_s
    }
  end

  def logging_error_query
    { 'type' => 'logging',
      'id' => @control.setup_logging_errors.index(@error_sample).to_s
    }
  end

  def alias_error_query
    { 'type' => 'alias',
      'id' => @control.setup_alias_errors.index(@error_sample).to_s
    }
  end

  def document_error_query
    { 'type' => 'document',
      'id' => @control.setup_document_errors.index(@error_sample).to_s
    }
  end

  def filter_error_query
    { 'type' => 'filter',
      'id' => @control.setup_filter_errors.index(@error_sample).to_s
    }
  end
end
