# $Id: SetupAlias.rb,v 1.4 2005/01/01 04:47:51 toki Exp $

require 'forwardable'

class SetupAlias < WPM::PageContext
  def init_context
    @driver = driver
    @pos = @driver.params['pos'].to_i
    @control = page_option(:control)
    @list = @control.aliases
    len = @list.length
    if (0 <= @pos && @pos < len) then
      # nothing to do.
    elsif (@pos == len) then
      @list.add_entry
    else
      raise 'out of range'
    end
    @params = @list[@pos]
  end

  attr_reader :pos
  def_delegator :@list, :modified_count
  def_delegator :@list, :modified_count=

  def index
    @pos + 1
  end

  def_delegator :@params, :alias_path
  def_delegator :@params, :alias_path=
  def_delegator :@params, :orig_path
  def_delegator :@params, :orig_path=
  def_delegator :@params, :virtual_host
  def_delegator :@params, :virtual_host=

  def write
    @control.set_aliases(@list)
    @driver.redirect('AliasMap')
    nil
  end

  def cancel
    @driver.redirect('AliasMap')
    nil
  end

  def reload_query
    { 'pos' => @pos.to_s }
  end
end
