# $Id: config_ctrl.rb,v 1.8 2005/02/24 15:19:07 toki Exp $

require 'wpm'
require 'wpm/rucydriver'
require 'wpm/rexml'
require 'yaml/store'
require 'rucy/jconv'
require 'rucy/fork'
require 'rucy/properties'
require 'rucy/params'
require 'rucy/control'
require 'rucy/config'

module Rucy
  module Config
    def config_ctrl(rep)
      # for wpm
      rep.set_block(:WPMWriter) { WPM::Writer.new(WPM::XMLAssistByREXML) }
      rep.set_block(:WebPageMakerDocument) {|writer| WebPageMakerDocument.new(writer) }

      # for rucy/jconv
      rep.set_block(:Jconv) { Jconv.new(rep) }

      # for rucy/fork
      rep.set_block(:Fork) { Fork.new(rep) }

      # for rucy/properties
      rep.set_class(:Store, YAML::Store)
      rep.set_block(:Properties) {|path| Properties.new(path, rep) }

      # for rucy/params
      rep.set_block(:AdminParams) { AdminParams.new(rep) }
      rep.set_value(:AdminParams_class, AdminParams)
      rep.set_block(:ServerParams) {|fork| ServerParams.new(fork, rep) }
      rep.set_value(:ServerParams_class, ServerParams)
      rep.set_block(:LoggingParams) { LoggingParams.new(rep) }
      rep.set_value(:LoggingParams_class, LoggingParams)
      rep.set_block(:AccessLogParams) { AccessLogParams.new(rep) }
      rep.set_value(:AccessLogParams_class, AccessLogParams)
      rep.set_block(:AliasList) { AliasList.new(rep) }
      rep.set_value(:AliasList_class, AliasList)
      rep.set_block(:DocumentList) {|factory| DocumentList.new(factory, rep) }
      rep.set_value(:DocumentList_class, DocumentList)
      rep.set_block(:FilterList) {|factory| FilterList.new(factory, rep) }
      rep.set_value(:FilterList_class, FilterList)

      # for rucy/control
      rep.set_block(:Control) { Control.new(rep) }

      rep
    end
    module_function :config_ctrl

    setup{|rep| config_ctrl(rep) }
  end
end
