# $Id: loader.rb,v 1.7 2005/02/05 04:34:17 toki Exp $

require 'forwardable'

module Rucy
  class SimpleLoader
    extend Forwardable

    def initialize
      @mod = Module.new
    end

    def load(path)
      @mod.module_eval(File.open(path) {|input| input.read }, path)
      nil
    end

    def_delegator :@mod, :constants
    def_delegator :@mod, :const_get
    def_delegator :@mod, :const_defined?
  end

  class ModuleFolder
    def initialize(load_path)
      @load_path = load_path
    end

    def scan
      Dir.foreach(@load_path) do |name|
	if (name !~ /^_/ && name =~ /\.rb$/) then
	  path = File.join(@load_path, name)
	  if (File.file? path) then
	    yield(path)
	  end
	end
      end

      nil
    end
  end
end
