# $Id: rep.rb,v 1.2 2004/12/13 16:30:09 toki Exp $

module Rucy
  class Repository
    class ValueHolder
      def initialize(value)
	@value = value
      end

      def call
	@value
      end
    end

    class ClassHolder
      def initialize(klass)
	@class = klass
      end

      def call(*args, &block)
	@class.new(*args, &block)
      end
    end

    def initialize
      @map = Hash.new
    end

    def set_value(key, value)
      @map[key] = ValueHolder.new(value)
      nil
    end

    def set_class(key, klass)
      @map[key] = ClassHolder.new(klass)
      nil
    end

    def set_block(key, &block)
      @map[key] = block
      nil
    end

    def fetch(key, *args, &block)
      unless (@map.include? key) then
	raise "not found an object associated with #{key.inspect}"
      end
      @map[key].call(*args, &block)
    end

    DEFAULT = self.new
  end
end
