#!/usr/local/bin/ruby
# $Id: test_sockutils.rb,v 1.2 2004/12/30 15:43:50 toki Exp $

require 'rubyunit'
require 'sockutils'

module TestRucy
  class TestSocketUtils < RUNIT::TestCase
    def test_socketpair
      s1, s2 = SocketUtils.socketpair
      assert((s1.kind_of? BasicSocket))
      assert((s2.kind_of? BasicSocket))
      s1.write('foo')
      assert_equal('foo', s2.read(3))
      s2.write('bar')
      assert_equal('bar', s1.read(3))
      s1.close
      s2.close
    end

    def test_tcp_socketpair
      s1, s2 = SocketUtils.tcp_socketpair
      assert_instance_of(TCPSocket, s1)
      assert_instance_of(TCPSocket, s2)
      s1.write('foo')
      assert_equal('foo', s2.read(3))
      s2.write('bar')
      assert_equal('bar', s1.read(3))
      s1.close
      s2.close
    end
  end
end
